package fr.alnotz.quaternion;

/**
 * Interface d’étiquette pour tout nombre quaternionique et dual.
 */
public interface IsDualQuaternion {
    IsQuaternion getR();
    IsQuaternion getD();
    IsDual getS();
    IsDual getI();
    IsDual getJ();
    IsDual getK();
    double getRS();
    double getRI();
    double getRJ();
    double getRK();
    double getDS();
    double getDI();
    double getDJ();
    double getDK();
    void setR(IsQuaternion quaternion);
    void setD(IsQuaternion quaternion);
    void setS(IsDual dual);
    void setI(IsDual dual);
    void setJ(IsDual dual);
    void setK(IsDual dual);
    void setRS(double rs);
    void setRI(double ri);
    void setRJ(double rj);
    void setRK(double rk);
    void setDS(double ds);
    void setDI(double di);
    void setDJ(double dj);
    void setDK(double dk);
    IsDualQuaternion plus(IsDualQuaternion dualQuaternion);
    IsDualQuaternion times(IsDualQuaternion dualQuaternion);
    boolean equals(IsDualQuaternion dualQuaternion);
    String toString();
}
